/* Ejemplo del tutorial de Xintro.html */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

 Display *dis;
 int screen;
 Window win;
 GC gc;

void init_x() {
  /* Para coger los colores blanco y negro */
  unsigned long black,white;

  dis=XOpenDisplay((char *)0);
  screen=DefaultScreen(dis);
  black=BlackPixel(dis,screen);
  white=WhitePixel(dis,screen);

  /* creamos la ventana */
  win=XCreateSimpleWindow(dis,DefaultRootWindow(dis),0,0,  
                          400, 300, 5, white, black);

  /* propiedades de la ventana */
  XSetStandardProperties(dis,win,"Hola Mundo :)","Hola!",None,NULL,0,NULL);

  /* seleccionamos qu tipos de eventos deseamos recibir */
  XSelectInput(dis, win, ExposureMask|ButtonPressMask|KeyPressMask);

  gc=XCreateGC(dis, win, 0,0);        
  XSetBackground(dis,gc,white);
  XSetForeground(dis,gc,black);
  XClearWindow(dis, win);
  XMapRaised(dis, win);
}

void close_xwin() {
  XFreeGC(dis, gc);
  XDestroyWindow(dis,win);
  XCloseDisplay(dis);
}

/*--- Funcion principal main -----------------*/
void main()
{

 XEvent event;    /* donde guardar los eventos. */
  char key;       /* para cdigos de teclado */

 init_x();        /* creamos ventana, etc. */

  /* Bucle infinito de eventos */
  while(1) {
    /* Coger el evento siguiente en nuestra variable de eventos */
    /*  Solo nos son enviados eventos que pedimos en XselectInput */
    XNextEvent(dis, &event);

    switch(event.type)      /* que evento ha ocurrido? */
    {  

    case Expose:
            /* si es necesario, redibujar la pantalla */
            if( event.xexpose.count == 0 ) ;
              ; /*  redraw(); */
            break;
    
    case KeyPress:    /* fue una tecla? */
            key = XKeycodeToKeysym(dis, event.xkey.keycode, 0);
            if(key == 'q') close_xwin();
            printf("has pulsado la tecla %c !\n",key);
            break;
    
    case ButtonPress:    /* boton del raton? */
      printf("Pulsaste un botn en (%i,%i)\n",
             event.xbutton.x,event.xbutton.y);
             break;
      }
      
  }
 close_xwin();
 
}


